package cz.cvut.fel.pr1.week3;

import kareltherobot.FelKarel;

public class Lecture3Karel extends FelKarel {

    final int NORTH = 0,
              EAST  = 1,
              SOUTH = 2,
              WEST  = 3;
    
    int orientation = 0;
    int x = 0;
    int y = 0;
    
    @Override
    public void execute() {
        int j = 0;
        goToWall();
        x = 0;
        y = 0;
        goAlongWall();
        turnOff();
    }
    
    void goToWall() {
        while (!isInFrontOfWall()) {
            step();
        }
        rotateLeft();
    }
    
    void goAlongWall() {
        do {
            if (!wallOnRight()) {
                rotateRight();
            }
            
            while (isInFrontOfWall()) {
                rotateLeft();
            }
            
            step();
            
            if (isOnBeeper()) {
                moveBeeperAwayFromWall();
            }
            
        } while (x != 0 || y != 0);
    }
    
    boolean wallOnRight() {
        rotateRight();
        boolean out = isInFrontOfWall();
        rotateLeft();
        return out;
    }
    
    void moveBeeperAwayFromWall() {
        pickBeeper();
        rotateLeft();
        step();
        putBeeper();
        rotateLeft();
        rotateLeft();
        step();
        rotateLeft();
    }
    
    void step() {
        move();
        
        switch (orientation) {
            case NORTH:
                y += 1;
                break;
                
            case EAST:
                x -= 1;
                break;
                
            case SOUTH:
                y -= 1;
                break;
                
            case WEST:
                x += 1;
                break;
        }
    }
    
    void rotateLeft() {
        turnLeft();
        
        orientation += 1;
        if (orientation > 3) {
            orientation = 0;
        }
    }
    
    void rotateRight() {
        for (int i = 0; i < 3; i++) {
            rotateLeft();
        }
    }
}
