package cz.cvut.fel.pr1.week9;

public class Ellipse {
    
    private final double a, b;
    private double area = -1;

    public Ellipse() {
        this(10, 20);
    }
    
    public Ellipse(double a, double b) {
        if (a <= 0 || b <= 0) { // check the input parameters
            throw new IllegalArgumentException("The axes must be positive: a = "
                    + a + ", b = " + b);
        }
        
        this.a = a;
        this.b = b;
    }
    
    /**
     * Calculates the approximation of the perimeter. 
     * 
     * The approximation is bound to be within the 5% of the real value.
     * 
     * @return the perimeter of the ellipse
     */
    public double perimeter() {
        return 2 * Math.PI * Math.sqrt((a * a + b * b) / 2);
    }
    
    /**
     * Calculates the area of the ellipse.
     * 
     * The calculated value is cached, so that in the next call the cached value
     * is returned.
     * 
     * @return area of the ellipse
     */
    public double area() {
        if (area == -1) { // we can cache the area
            area = Math.PI * a * b;
        }
        return area;
    }
    
}
